<?php

/**
 * Class for network settings
 */
class NetConf {

	function save($ba, $bc) {

     if ($_POST['action'] == 'apply') {
	    # configure basic network settings
	    $fields= array('lan-ipaddr', 'lan-netmask', 'lan-gateway',
		'lan-nameserver', 'lan-mtu','lan-dhcp','wan-dhcp',
		'wan-ipaddr', 'wan-netmask', 'wan-gateway','bonding-mode',
		'bonding-miimon','bonding-updelay','bonding-downdelay');
	    # delete every lan setting
	    foreach ($fields as $field)
		    $bc->delete('root', $field);

	    $bc->set('root', 'lan-mode', sqlite_escape_string($_POST['lan-mode']));

	    $bc->set('root', 'lan-dhcp', sqlite_escape_string($_POST['dhcp']));
		if (!in_array($bc->get('root', 'lan-dhcp'), array('yes', '1'))) {
			# configure static networking
			$bc->set('root', 'lan-ipaddr', sqlite_escape_string($_POST['ipaddr']));
			$bc->set('root', 'lan-netmask', sqlite_escape_string($_POST['netmask']));
			$bc->set('root', 'lan-gateway', sqlite_escape_string($_POST['gateway']));
			$bc->set('root', 'lan-mtu', sqlite_escape_string(intval($_POST['lan_mtu'])));

			# configure nameservers
			if (strlen($_POST['lan_nameserver']) != 0) {
			    $nameserver = $_POST['lan_nameserver'] . ((strlen($_POST['lan_nameserver2']) != 0) ? ';' . $_POST['lan_nameserver2'] : '');
			    $bc->set('root', 'lan-nameserver', sqlite_escape_string($nameserver));
			} else {
			    $bc->delete('root', 'lan-nameserver');
			}
		}

	    switch ($bc->get('root', 'lan-mode')) {
		case 'lan-wan':
		    $bc->delete('root', 'lan-gateway');
		    $bc->set('root', 'wan-dhcp', sqlite_escape_string($_POST['wan-dhcp']));
		    if ($_POST['wan-dhcp'] != "1") {
			# configure static networking
			$bc->set('root', 'lan-dhcp', sqlite_escape_string("no"));
			$bc->set('root', 'wan-ipaddr', sqlite_escape_string($_POST['wan-ipaddr']));
			$bc->set('root', 'wan-netmask', sqlite_escape_string($_POST['wan-netmask']));
			$bc->set('root', 'wan-gateway', sqlite_escape_string($_POST['wan-gateway']));
		    }


		    break;
		case 'bonding':
		    $bc->set('root', 'bonding-mode', sqlite_escape_string($_POST['bonding-mode']));
		    $bc->set('root', 'bonding-miimon', sqlite_escape_string($_POST['bonding-miimon']));
		    $bc->set('root', 'bonding-updelay', sqlite_escape_string($_POST['bonding-updelay']));
		    $bc->set('root', 'bonding-downdelay', sqlite_escape_string($_POST['bonding-downdelay']));

		    break;
	    }


	    # configure misc. network settings
	    $bc->set('root', 'hostname', sqlite_escape_string($_POST['hostname']));
	    $bc->set('root', 'ncs_mode', $_POST['ncs_mode']);
	    $bc->set('root', 'beroAvahi-enabled', (isset($_POST['beroAvahi-enabled']) ? '1' : '0'));

	    # configure vlan
	    if (isset($_POST['vlanenable'])) {
		$bc->set('root', 'vlan-enable', sqlite_escape_string($_POST['vlanenable']));
		$bc->set('root', 'vlan-id', sqlite_escape_string($_POST['vlanid']));
		$bc->set('root', 'vlan-prio', sqlite_escape_string($_POST['vlan-prio']));
	    } else {
		$bc->delete('root', 'vlan-enable');
		$bc->delete('root', 'vlan-id');
		$bc->delete('root', 'vlan-prio');
	    }
	    # configure routing
	    $routing = '';
	    for ($i = 0; $i < count($_POST['route_net']); $i++) {
		if (($_POST['route_net'][$i] != '') && ($_POST['route_netmask'][$i] != '') && ($_POST['route_gateway'][$i] != '')) {
		    $routing .= ((strlen($routing) != 0) ? ',' : '') . $_POST['route_net'][$i] . "/" . $_POST['route_netmask'][$i] . "/" . $_POST['route_gateway'][$i];
		}
	    }
	    $bc->set('root', 'routing', $routing);

	    $ret = Helper::activate(3, true, $_GET['m'], ACTIVATE) .
		    '<br /><div class="text-center" style="color:red;"><strong>' . NETWORK_CONFIGURATION_APPLIED_DIS . '</strong></div>' . "\n";
	}

	$file_error = '/tmp/error_certificate.log';
	if (isset($_POST['errorCert']) && $_POST['errorCert'] && file_exists($file_error))
	{
		exec('/bin/rm -f '. $file_error);
	}
	if (isset($_POST['httpsOnly'])) {
			$ba->set('httpsOnly', sqlite_escape_string($_POST['httpsOnly']));
			$option = 1;

			$file_name = $_FILES["uploadfile"]["name"];
			$tmp_file = $_FILES["uploadfile"]["tmp_name"];
			if ($_FILES["uploadfile"]["name"] != "") {
				if ($_FILES["uploadfile"]["size"] > 51200) { //50 kB
					$ret="<div class='text-center'><img src='./includes/images/punkt_rot.gif'><font color='red'>" . HTTPS_INVALID_FILE_SIZE . "</font></div>";
				} else {

					if (file_exists($file_error))
					{
						exec('/bin/rm -f '. $file_error);
					}	

					unset($return);
					exec('/usr/local/bin/openssl x509 -in ' . $tmp_file . ' -noout -text', $output, $return);
					if ($return == 0) {
						@unlink("/usr/conf/berofix.pem");
						exec("/bin/cp " . $tmp_file . " /usr/conf/berofix.pem");
						$option = 3;
						$ret.="<div class='text-center'><img src='./includes/images/punkt_gruen.gif' /><font color='black'>" . SIP_GENERAL_UPLOAD_SUCCESS_DIS . "</font></div>";
					} else {
						$ret.="<div class='text-center'><img src='./includes/images/punkt_rot.gif'><font color='red'>" . HTTPS_INVALID_CERT_ERROR . "</font></div>";
					}
				}
			}
			$ret.=Helper::activate($option, true, $_GET['m'], ACTIVATE);
		}


		return($ret);
	}

	function mode($bc){
	    if ($bc->get('root', 'lan-ports')==2){
		$lan_mode= array(
		    "single" => "Single mode",
		    "lan-wan" => "LAN-WAN",
		    "bonding" => "Ethernet bonding");
		$select = '<select class="form-control" name="lan-mode">';
		foreach ($lan_mode as $mode => $desc){
		    $selected = ($bc->get('root', 'lan-mode') == $mode) ? 'selected' : null;
		    $select .= '<option value="' . $mode . '" ' . $selected . '> ' . $desc . ' <br>'."\n";
		}
		$select .= '</select>';
		return '<tr>' .
		'<td><strong>' . NETWORK_LAN_MODE_DIS . '</strong></td>'
		. '<td>' . $select . '</td>'
		. '</tr>';
	    }else{
		return;
	    }
	}

	function bonding($bc) {
		$bonding_mode= array(
		    "0" => "balance-rr",
		    "1" => "active-backup",
		    "2" => "balance-xor",
		    "3" => "broadcast",
		    "4" => "802.3ad",
		    "5" => "balance-tlb",
		    "6" => "balance-alb",
		    );
		if ($bc->get('root', 'bonding-mode') == '') $bc->set('root', 'bonding-mode','1');
		if ($bc->get('root', 'bonding-miimon') == '') $bc->set('root', 'bonding-miimon','100');
		if ($bc->get('root', 'bonding-updelay') == '') $bc->set('root', 'bonding-updelay','200');
		if ($bc->get('root', 'bonding-downdelay') == '') $bc->set('root', 'bonding-downdelay','200');
		$select = '<select name="bonding-mode">';
		foreach ($bonding_mode as $mode => $desc){
		    $selected = ($bc->get('root', 'bonding-mode') == $mode) ? 'selected' : null;
		    $select .= '<option value="' . $mode . '" ' . $selected . '> ' . $desc . ' <br>'."\n";
		}
		$select .= '</select>';
		return '<tbody id="bonding">'
		. '<tr>'
		. '<td><strong>' . NETWORK_BONDING_MODE_DIS . '</strong></td>'
		. '<td>' . $select . '</td>'
		. '</tr>'
		. '<tr>'
		. '<td><strong>' . NETWORK_BONDING_MIIMON_DIS . '</strong></td>'
		. '<td><input name="bonding-miimon" class="form-control" value="' . $bc->get('root', 'bonding-miimon') . '"></td>'
		. '</tr>'
		. '<tr>'
		. '<td><strong>' . NETWORK_BONDING_UPDELAY_DIS . '</strong></td>'
		. '<td><input name="bonding-updelay" class="form-control" value="' . $bc->get('root', 'bonding-updelay') . '"></td>'
		. '</tr>'
		. '<tr>'
		. '<td><strong>' . NETWORK_BONDING_DOWNDELAY_DIS . '</strong></td>'
		. '<td><input name="bonding-downdelay" class="form-control" value="' . $bc->get('root', 'bonding-downdelay') . '"></td>'
		. '</tr>'
		. '</tbody>';
	}

	function  lan_wan($bc) {
	    $dhcp=$bc->get("root","wan-dhcp");
	    return '<tbody id="wan">'
		. '<tr>'
		. '<th colspan="2" class="text-center">' . NETWORK_WAN_SETTING_DIS . '</th>'
		. '</tr>'
		. '<tr>' . "\n"
		. '<td colspan="2" class="text-center">' . "\n"
		. '<input type="radio" name="wan-dhcp" id="wan-dhcp" onclick="hide_wan($(\'#wan-static\').prop(\'checked\'));"  value="1"' . ($dhcp=="1" ? ' checked' : '') . '>'
		. 'DHCP' . "\n"
		. '<input type="radio" name="wan-dhcp" id="wan-static" onclick="hide_wan($(\'#wan-static\').prop(\'checked\'));" value="0"' . ($dhcp ? '' : ' checked') . ' ">'
		. NETWORK_STATIC_DIS . "\n"
		. '</td>' . "\n"
		. '</tr>' . "\n"
		. '<tr id="wan-ipaddr-tr">' . "\n"
		. '<td><strong>' . NETWORK_IP_ADDRESS_DIS . ':</strong></td>' . "\n"
		. '<td><input name="wan-ipaddr" class="form-control" type="text" size="15" id="wan-ipaddr" value="' . $bc->get('root', 'wan-ipaddr') . '"></td>' . "\n"
		. '</tr>' . "\n"
		. '<tr id="wan-netmask-tr">' . "\n"
		. '<td><strong>' . NETWORK_NETMASK_DIS . ':</strong></td>' . "\n"
		. '<td><input name="wan-netmask" class="form-control" type="text" size="15" id="wan-netmask" value="' . $bc->get('root', 'wan-netmask') . '"></td>' . "\n"
		. '</tr>' . "\n"
		. '<tr id="wan-gateway-tr">' . "\n"
		. '<td><strong>' . NETWORK_GATEWAY_DIS . ':</strong></td>' . "\n"
		. '<td><input name="wan-gateway" class="form-control" type="text" size="15" id="wan-gateway" value="' . $bc->get('root', 'wan-gateway') . '"></td>' . "\n"
		. '</tr>' . "\n"
		. '</tbody>';
	}

	function display() {
		$name = "NETWORK_TITLE_DIS";
		include('./includes/header.php');
		include('/usr/fallback/beroConf.php');

		require_once('./includes/lang.php');

		$bc = new beroConf('root');
		$ba = new beroAri();

		if (!$bc->valid()) {
			$ret.= '<h3>Error:</h3><b>Failed to connect to config database!</b><br />';
			exit(0);
		}

		// args
		$m = $_GET['m'];
		$q = $_GET['q'];
		if (isset($_POST['httpsOnly'])) {
			$ret .= $this->save($ba, $bc);
		} elseif ($_POST['action'] == 'apply') {
			if ($_POST['dhcp'] == 'yes') {
				$ret .= $this->save($ba, $bc);
			} else {
				if ($_POST['ipaddr'] != $_POST['gateway']) {
					$result = exec('/usr/sbin/netconfigverify ' . $_POST['ipaddr'] . ' ' . $_POST['netmask'] . ' ' . $_POST['gateway'] . ' 2>&1');
					if (substr_count($result, 'Failed') > 0) {
						$ret .= '<br /><div class="center"><b><font color="red">' . NETWORK_FAILED_ERROR_DIS . '</font></b></div>' . "\n";
					} else {
						$ret .= $this->save($ba, $bc);
					}
				} else {
					$ret .= '<br /><div class="center"><font color=red><b>' . NETWORK_FAILED_ERROR_DIS . '</b></font></div>' . "\n";
				}
			}
		}


		$iface = $bc->get('root', 'lan-iface');
		$dns = explode(';', $bc->get('root', 'lan-nameserver'));
		$dhcp = in_array($bc->get('root', 'lan-dhcp'), array('yes', '1'));
		//Show default values for DNS and secondary DNS
		if ($dhcp) {
			$dns[0] = '8.8.8.8';
			$dns[1] = '8.8.4.4';
		}

		if($ba->get('gui_mode')=='simple') $simple_class='simple';

		$ncsDetectMode = $bc->get('root', 'ncs_mode');

		$ret .= '<br/>' . "\n" .
			'<form name="networkform" id="networkform" method="POST" action="" onsubmit="return (checkvlan(vlanenable.checked));">' . "\n" .
			'<input type="hidden" name="action" value="apply" />' . "\n" .
			'<div class="table-responsive">'
			. '<table id="table" class="table table-striped table-bordered" style="max-width:600px; margin:auto;">' . "\n" .
			'<tr><th colspan="2" class="text-center">' . NETWORK_TABLE_HEADER_DIS . '</th></tr>' . "\n" .
			$this->mode($bc) .
			'<tr id="header-lan">' . "\n" .
			'<th colspan="2">' . NETWORK_LAN_SETTING_DIS. '</th>' . "\n" .
			'</tr>' . "\n" .
			'<tr id="header-bonding">' . "\n" .
			'<th colspan="2" >' . NETWORK_BONDING_SETTING_DIS. '</th>' . "\n" .
			'</tr>' . "\n" .
			'<tr id="lan-dhcp-tr">' . "\n" .
			'<td colspan="2" class="text-center">' . "\n" .
			'<input type="radio" name="dhcp" id="lan_dhcp" onclick="hide_netconfig(document.getElementById(\'lan_static\').checked);" onmouseover=\'Tip("' . NET_CONF_DHCP . '")\' onmouseout="UnTip()" value="yes"' . ($dhcp ? ' checked' : '') . ' />' .
			'DHCP' . "\n" .
			'<input type="radio" name="dhcp" id="lan_static" onclick="hide_netconfig(document.getElementById(\'lan_static\').checked);" onmouseover=\'Tip("' . NET_CONF_STATIC . '")\' onmouseout="UnTip()" value="no"' . ($dhcp ? '' : ' checked') . ' " />' .
			NETWORK_STATIC_DIS . "\n" .
			'</td>' . "\n" .
			'</tr>' . "\n" .
			'<tr id="lan_ipaddr">' . "\n" .
			'<td><b><label for="ipaddr">' . NETWORK_IP_ADDRESS_DIS . '</label>:</b></td>' . "\n" .
			'<td><input name="ipaddr" class="form-control" type="text" size="15" id="ipaddr" onmouseover=\'Tip("' . NET_CONF_IP_ADDRESS . '")\' onmouseout="UnTip()" value="' . $bc->get('root', 'lan-ipaddr') . '" /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr id="lan_netmask">' . "\n" .
			'<td><b><label for="netmask">' . NETWORK_NETMASK_DIS . '</label>:</b></td>' . "\n" .
			'<td><input name="netmask" class="form-control" type="text" size="15" id="netmask" onclick="if (netmask.value==\'\') netmask.value=makeNetMask(ipaddr.value);"' .
			'onmouseover=\'Tip("' . NET_CONF_NETMASK . '")\' onmouseout="UnTip()" value="' . $bc->get('root', 'lan-netmask') . '" /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr id="lan_gateway">' . "\n" .
			'<td><b><label for="gateway">' . NETWORK_GATEWAY_DIS . '</label>:</b></td>' . "\n" .
			'<td><input name="gateway" class="form-control" type="text" size="15" id="gateway" onmouseover=\'Tip("' . NET_CONF_GATEWAY . '")\' onmouseout="UnTip()" value="' . $bc->get('root', 'lan-gateway') . '" /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr id="lan_dns1">' . "\n" .
			'<td><b><label for="lan_nameserver">' . NETWORK_PRIMARY_NAME_SERVER_DIS . '</label>:</b></td>' . "\n" .
			'<td><input name="lan_nameserver" class="form-control" type="text" size="15" id="lan_nameserver" onmouseover=\'Tip("' . NET_CONF_NAMESERVER . '")\' onmouseout="UnTip()" value="' . $dns[0] . '" /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr id="lan_dns2">' . "\n" .
			'<td><b>' . NETWORK_SECONDARY_NAME_SERVER_DIS . ':</b></td>' . "\n" .
			'<td><input name="lan_nameserver2" class="form-control" type="text" size="15" id="lan_nameserver2" onmouseover=\'Tip("' . NET_CONF_SECONDARY_NAMESERVER . '")\' onmouseout="UnTip()" value="' . $dns[1] . '" /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr id="lan_hostname">' . "\n" .
			'<td><b>' . NETWORK_HOSTNAME_DIS . ':</b></td>' . "\n" .
			'<td><input name="hostname" class="form-control" type="text" size="15" checkDigChar="true" id="hostname" value="' . $bc->get('root','hostname') . '" /></td>' . "\n" .
			'</tr>' . "\n" .
			$this->bonding($bc) .
			$this->lan_wan($bc) .
			'<tr class="'.$simple_class.'"><th colspan="2">' . NETWORK_ADVANCED_DIS . '</th></tr>' . "\n" .
			'<tr class="'.$simple_class.'" id="lan_mtusize">' . "\n" .
			'<td><b>' . NETWORK_MTU_SIZE_DIS . ':</b></td>' . "\n" .
			'<td><input name="lan_mtu" class="form-control" type="text" size="15" id="lan_mtu" onmouseover=\'Tip("' . NET_CONF_MTU_SIZE . '")\' onmouseout="UnTip()" value="' . $bc->get('root', 'lan-mtu') . '" /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr class="'.$simple_class.'">' . "\n" .
			'<td><b>' . NETWORK_AVAHI_DIS . ':</b></td>' . "\n" .
			'<td><input type="checkbox" name="beroAvahi-enabled" value="1"' . (($bc->get('root', 'beroAvahi-enabled') == '1') ? ' checked' : '') . ' /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr class="'.$simple_class.'">' . "\n" .
			'<td><b>' . NETWORK_CONFIG_SERVER_DIS . ':</b></td>' . "\n" .
			'<td>' . "\n" .
			'<select name="ncs_mode" class="form-control">' . "\n" .
			'<option value="on"' . (($ncsDetectMode == 'on') ? ' selected="selected"' : '') . '>' . NETWORK_CONFIG_SERVER_OPTION_ON . '</option>' . "\n" .
			'<option value="detectonly"' . (($ncsDetectMode == 'detectonly') ? ' selected="selected"' : '') . '>' . NETWORK_CONFIG_SERVER_OPTION_OD . '</option>' . "\n" .
			'<option value="off"' . (($ncsDetectMode == 'off') ? ' selected="selected"' : '') . '>' . NETWORK_CONFIG_SERVER_OPTION_OFF . '</option>' . "\n" .
			'</select>' . "\n" .
			'</tr>' . "\n" .
			'<tr class="'.$simple_class.'">' . "\n" .
			'<td><b>' . NETWORK_VLAN_ENABLE_DIS . ':</b></td>' . "\n" .
			'<td><input name="vlanenable" type="checkbox" id="vlanenable" onclick="show_vlan(document.getElementById(\'vlanenable\').checked);" value="1"' . (($bc->get('root', 'vlan-enable') == 1) ? ' checked' : '') . '/></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr class="'.$simple_class.'" id="vlan_id">' . "\n" .
			'<td><b><label for="vlanid">' . NETWORK_VLAN_ID_DIS . '</label>:</b></td>' . "\n" .
			'<td><input name="vlanid" class="form-control" type="text" size="15" id="vlanid" value="' . $bc->get('root', 'vlan-id') . '" /></td>' . "\n" .
			'</tr>' . "\n" .
			'<tr class="'.$simple_class.'" id="vlan_prio">' . "\n" .
			'<td><b>' . NETWORK_VLAN_PRIORITY_DIS . ':</b></td>' . "\n" .
			'<td>' . $this->vlan_prio() . '</td>' . "\n" .
			'</tr>' . "\n" .
			$this->routing($simple_class) . "\n" .
			'<tr class="'.$simple_class.'" id="add_route">' . "\n" .
			'<td colspan="2" class="text-center"><input type="button" class="btn btn-default" id="add_route_button" value="' . BUTTON_ADD_ROUTE_ENTRY . '" /></td>' . "\n" .
			'</tr>' . "\n" .
			'</table>' . "\n" .
			'</div>'
			. '<br>'
			. '<div class="text-center">'
			. '<input type="submit" name="Apply" class="btn btn-default" value="' . BUTTON_SAVE . '" onmouseover=\'Tip("' . NET_CONF_APPLY . '")\' onmouseout="UnTip()" />'
			. '</div>'
			. '</form>' . "\n"
			. '<br>'
			. '<div class="text-center" ><i>'.REQUIRED_FIELDS.'</i></div>'. "\n"
			. '<br />' . "\n" 
			. '<br />' . "\n" 
			. $this->httpsSettingTable()
			. '<script type="text/javascript" src="misc/script/netconf.js"></script>';

		return($ret);
	}

	/*
	 * Der boolesche Wert von httpsOnly, der in der Datenbank gespeichert ist wird zurückgegeben
	 * in der Form eines Checkboxs und nachher angezeigt.
	 */

	function https_only() {
		$ba = new beroAri();
		$proxy_enable = $ba->get("httpsOnly");
		if ($proxy_enable == "1")
			return "<input type='hidden' name='httpsOnly' value='0'>"
			. "<input type='checkbox' name='httpsOnly' value='1' checked>";
		else
			return "<input type='hidden' name='httpsOnly' value='0'>"
			. "<input type='checkbox' name='httpsOnly' value='1'>";
	}

	function httpsSettingTable() {

		$table = "<form ENCTYPE=\"multipart/form-data\" action='' method='POST'>"
			. "<input type=hidden name=m value=" . $_GET['m'] . ">"
			. "<div class='table-responsive'>"
			. "<table class='table table-striped table-bordered' style='max-width:600px; margin:auto;'>"
			. "<tr>"
			. "<th colspan='2' class='text-center'>" . HTTPS_TABLE_HEADER_DIS . "</th>"
			. "</tr>"
			. "<tr>"
			. "<td><b>" . HTTPS_UPLOAD_CERTIFICATE_DIS . ":</b></td>"
			. "<td nowrap><input type='file' size='28' name='uploadfile'></td>"
			. "</tr>";
		if (file_exists("/usr/conf/berofix.pem") && !is_link("/usr/conf/berofix.pem")) {
			$table .= "<tr>"
				. "<td><b>" . HTTPS_CERTIFICATE_DIS . ":</b></td>"
				. "<td>"
				. "<input type='button' class='btn btn-default' value='" . HTTPS_DOWNLOAD_CERTIFICATE_DIS . "' "
				. "onclick=\" window.location.href='misc/files_download.php?option=certificate_https';\">&nbsp;&nbsp;"
				. "<input type='button' class='btn btn-default' value='" . HTTPS_DELETE_CERTIFICATE_DIS . "' "
				. "onclick=\"javascript:if (confirm('" . HTTPS_DELETE_CERTIFICATE_MESS_DIS . "?')==true) "
				. "window.location.href='misc/deletefile.php?m=" . $_GET['m'] . "&option=certificate_https';\">"
				. "</td>"
				. "</tr>";
		}
		if (file_exists('/tmp/error_certificate.log'))
		{ 
			$table .= "<tr>"
				. "<td><b>" . ERROR_HTTPS_REMOVE_CERTIFICATE_MESSAGE_DIS . ":</b></td>"
				. "<td><input type='checkbox' name='errorCert' value='1'/></td>"
				. "</tr>";
		} 
		$table .="<tr>"
			. "<td><b>" . HTTPS_ONLY_DIS . ":</b></td>"
			. "<td>" . $this->https_only() . "</td>"
			. "</tr>";
		$table .= "</table>"
			. "</div>"
			. "<div class='text-center'>"
			. "<br>"
			. "<input name='submit' class='btn btn-default' type='submit' value='" . BUTTON_SAVE . "'>"
			. "</div>"
			. "</form>";
		return $table;
	}

	function vlan_prio() {

		$bc = new beroConf('root');

		$i = 0;
		$ret = '<select name="vlan-prio">' . "\n";
		foreach (array('000', '001', '010', '011', '100', '101', '110', '111') as $bit) {
			$ret .= '<option value="' . $bit . '"' . (($bc->get('root', 'vlan-prio') == $bit) ? ' selected' : '') . '>' . $i++ . '</option>' . "\n";
		}
		$ret .= '</select>' . "\n";

		return($ret);
	}

	function routing($simple_class=null) {

		$bc = new beroConf('root');
		$routing = $bc->get('root', 'routing');

		if (strlen($routing) == 0) {
			return('');
		}

		$res = '';
		foreach (explode(',', $routing) as $route) {
			list($route_net, $route_netmask, $route_gateway) = explode('/', $route);
			$res .= '<tr class="'.$simple_class.'">' . "\n" .
				'<td><strong>Route target</strong></td>' . "\n" .
				'<td>' .
				'<div class=\'row\'>' .
				'<div class=\'col-lg-6\'><input name="route_net[]" verifyIP="true" class="net form-control" value="' . $route_net . '" /></div>' .
				'<div class=\'col-lg-1\'>/</div>' .
				'<div class=\'col-lg-5\'><input name="route_netmask[]" digits="true" required="true" min="0" max="32" size="2" maxlength="2" class="netmask form-control" value="' . $route_netmask . '" /></div>' .
				'</div>' .
				'</td>' . "\n" .
				'</tr>' . "\n" .
				'<tr class="'.$simple_mode.'">' . "\n" .
				'<td><strong>Route gateway</strong></td>' . "\n" .
				'<td><input name="route_gateway[]" verifyIP="true" class="gateway form-control" value="' . $route_gateway . '" size="24" /></td>' . "\n" .
				'</tr>' . "\n";
		}

		return($res);
	}

}

?>
